/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __surface_SurfaceTrianglesHoudini_h__
#define __surface_SurfaceTrianglesHoudini_h__

namespace fe
{

/**************************************************************************//**
	@brief Houdini Trianglar Surface

	@ingroup surface
*//***************************************************************************/
class FE_DL_EXPORT SurfaceTrianglesHoudini: public SurfaceTriangles
{
	public:
							SurfaceTrianglesHoudini(void);
virtual						~SurfaceTrianglesHoudini(void);

							//* As Protectable
virtual	Protectable*		clone(Protectable* pInstance=NULL);

							//* Houdini specific
		void				setGdp(const GU_Detail* a_pGdp)	{ m_pGdp=a_pGdp; }
const	GU_Detail*			gdp(void)						{ return m_pGdp; }

	protected:

virtual	void				cache(void);
virtual	void				cacheResolve(void);

	private:
		void				calcBoundingSphere(void);

const	GU_Detail*			m_pGdp;
};

} // namespace

#endif /* __surface_SurfaceTriangles_h__ */

