/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "operator.pmh"

namespace fe
{

FE_DL_PUBLIC sp<Master> OperatorContext::ms_spMaster;

void OperatorContext::loadLibraries(void)
{
	sp<Registry> spRegistry=master()->registry();

	String libs;
	System::getEnvironmentVariable(m_libEnvVar, libs);
	if(libs.empty())
	{
		System::getEnvironmentVariable("FE_OPERATOR_LIBS", libs);
	}
	if(libs.empty())
	{
		libs="fexOperatorDL";
	}

	feLog("OperatorContext:loadLibraries managing \"%s\"\n",libs.c_str());

	while(!libs.empty())
	{
		String lib=libs.parse("'",":");
		if(lib.empty())
		{
			break;
		}
		Result result=spRegistry->manage(lib);
		feLog("OperatorContext:loadLibraries manage \"%s\" result=%p\n",
				lib.c_str(),result);
	}
}

} // namespace
