/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __operator_OperatorContext_h__
#define __operator_OperatorContext_h__

namespace fe
{

/**************************************************************************//**
    @brief shared FE context for Operator plugins

	@ingroup operator

*//***************************************************************************/
class FE_DL_EXPORT OperatorContext
{
	public:
					OperatorContext(void)
					{
						feLog("OperatorContext %p\n",this)
						m_spMasterHold=ms_spMaster;
					}
virtual				~OperatorContext(void)
					{
						feLog("~OperatorContext %p\n",this)
						m_spMasterHold=NULL;
						m_spScope=NULL;
						if(ms_spMaster.isValid())
						{
							feLog("  Master count is %d\n",
									ms_spMaster->count());
						}
						if(ms_spMaster.isValid() && ms_spMaster->count()==1)
						{
							feLog("  releasing Master\n");
							ms_spMaster=NULL;
						}
					}

/*
static	sp<Master>	master(void)
					{
						if(!ms_spMaster.isValid())
						{
							ms_spMaster=new Master();
						}
						feLog("OperatorContext::master %p\n",ms_spMaster.raw())
						m_spMasterHold=ms_spMaster;
						return ms_spMaster;
					}
*/
		sp<Master>	master(void)
					{
						if(!ms_spMaster.isValid())
						{
							ms_spMaster=new Master();
						}
//						feLog("OperatorContext::master %p\n",ms_spMaster.raw())
						m_spMasterHold=ms_spMaster;
						return ms_spMaster;
					}
		sp<Scope>	scope(void)
					{
						if(!m_spScope.isValid() && master().isValid())
						{
							m_spScope=master()->catalog()->catalogComponent(
									"Scope","OperatorScope");

							feLog("OperatorContext::scope 0x%p\n",
									m_spScope.raw())
						}
						return m_spScope;
					}

		void		loadLibraries(void);

	protected:
						String		m_libEnvVar;

	private:

static	FE_DL_PUBLIC	sp<Master>	ms_spMaster;
						sp<Master>	m_spMasterHold;
						sp<Scope>	m_spScope;
};

} // namespace

#endif /* __operator_OperatorContext_h__ */
