/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#include "operator.pmh"
#include "platform/dlCore.cc"

using namespace fe;

extern "C"
{

FE_DL_EXPORT void ListDependencies(List<String*>& list)
{
	list.append(new String("feSignalDL"));
}

FE_DL_EXPORT Library* CreateLibrary(sp<Master> spMaster)
{
	assertMath(spMaster->typeMaster());

	Library *pLibrary = new Library();
	pLibrary->add<OperatorDrawTest>(
			"OperatorSurfaceI.OperatorDrawTest.fe");
	pLibrary->add<OperatorSurfaceAttrCreate>(
			"OperatorSurfaceI.OperatorSurfaceAttrCreate.fe");
	pLibrary->add<OperatorSurfaceCopy>(
			"OperatorSurfaceI.OperatorSurfaceCopy.fe");
	pLibrary->add<OperatorSurfaceCurve>(
			"OperatorSurfaceI.OperatorSurfaceCurve.fe");
	pLibrary->add<OperatorSurfaceSummary>(
			"OperatorSurfaceI.OperatorSurfaceSummary.fe");
	pLibrary->add<OperatorSurfaceWave>(
			"OperatorSurfaceI.OperatorSurfaceWave.fe");
	return pLibrary;
}

}
