import sys
forge = sys.modules["forge"]

import os.path

def setup(module):

	deplibs =	forge.corelibs + [
				"feSignalLib",
				"fexMathLib",
				"fexGeometryDLLib",
				"fexDataToolDLLib"]

	tests = [	'xIntersect' ]

	forge.tests += [
		("xIntersect.exe",	"",									None,None) ]

	if os.path.exists('../viewer'):
		deplibs += [ "fexViewerDLLib" ]

		tests += [	'xSurface' ]

		forge.tests += [
			("xSurface.exe",	"sphere 100",						None,None),
			("xSurface.exe",	"disk 100",							None,None),
			("xSurface.exe",	"plane 100",						None,None),
			("xSurface.exe",	"cylinder 100",						None,None),
			("xSurface.exe",	"triangle 100",						None,None),
			("xSurface.exe",	"oval 100",							None,None),
			("xSurface.exe",	"teapot 10",						None,None),
			("xSurface.exe",	"sphere \"*.DrawRayTrace\" 10",		None,None),
			("xSurface.exe",	"disk \"*.DrawRayTrace\" 10",		None,None),
			("xSurface.exe",	"plane \"*.DrawRayTrace\" 4",		None,None),
			("xSurface.exe",	"cylinder \"*.DrawRayTrace\" 10",	None,None),
			("xSurface.exe",	"triangle \"*.DrawRayTrace\" 10",	None,None),
			("xSurface.exe",	"oval \"*.DrawRayTrace\" 10",		None,None) ]
	else:
		sys.stdout.write("-viewer ")

	for t in tests:
		exe = module.Exe(t)
		forge.deps([t + "Exe"], deplibs)
