/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __grass_OperatorTwistBind_h__
#define __grass_OperatorTwistBind_h__

namespace fe
{

/**************************************************************************//**
	@brief Handler to wrap and twist geometry to follow bends in a curve

	@ingroup grass
*//***************************************************************************/
class FE_DL_EXPORT OperatorTwistBind: public Catalog,
	public Initialize<OperatorTwistBind>,
	public OperatorSurfaceCommon
{
	public:

					OperatorTwistBind(void)									{}
virtual				~OperatorTwistBind(void)								{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

static	Real		nearestPointOnCurve(const SpatialVector a_point,
							const sp<SurfaceAccessorI> a_spCurves,
							const I32 a_index);

	private:
};

} /* namespace */

#endif /* __grass_OperatorTwistBind_h__ */
