/*	Copyright (C) 2003-2010 Free Electron Organization
	Any use of this software requires a license.  If a valid license
	was not distributed with this file, visit freeelectron.org. */

/** @file */

#ifndef __grass_OperatorTwistWrap_h__
#define __grass_OperatorTwistWrap_h__

namespace fe
{

/**************************************************************************//**
	@brief Handler to wrap and twist geometry to follow bends in a curve

	@ingroup grass
*//***************************************************************************/
class FE_DL_EXPORT OperatorTwistWrap: public OperatorThreaded,
	public Initialize<OperatorTwistWrap>
{
	public:

					OperatorTwistWrap(void)									{}
virtual				~OperatorTwistWrap(void)								{}

		void		initialize(void);

					//* As HandlerI
virtual	void		handle(Record& a_rSignal);

virtual	void		run(I32 a_id,Range a_range);

	private:

		sp<SurfaceAccessibleI>		m_spInput;
		sp<SurfaceAccessibleI>		m_spOutput;
		sp<SurfaceAccessibleI>		m_spReference;
		sp<SurfaceAccessibleI>		m_spDeformed;
		String						m_facingName;
		String						m_attachName;
};

} /* namespace */

#endif /* __grass_OperatorTwistWrap_h__ */
