import sys
import os
import shutil
import re
forge = sys.modules["forge"]

re_lib = re.compile(r'.*\.(dll|so|lib|a)')

def setup(module):

	setup_dep(module)

	srclist = [
		"platform.pmh",
		"backtrace",
		"debug",
		"DL_Loader",
		"DualString",
		"Exception",
		"Result",
		"String",
		"System"
		]

	if forge.fe_os == 'FE_WIN32' or forge.fe_os == 'FE_WIN64':
		module.Lib("fePlatform",srclist)
	elif forge.fe_os == 'FE_OSX':
		lib = module.DLL("fePlatform",srclist)
		forge.deps("fePlatformLib", ["feMemoryLib"])
	else:
		module.DLL("fePlatform",srclist)

	module.Module('test')


def setup_dep(module):
	deps_path = os.path.join(os.path.dirname(forge.rootPath), 'dep')
	if os.path.exists(deps_path):
		deps = os.listdir(deps_path)
		for dep in deps:
			lib_path = os.path.join(os.path.dirname(forge.rootPath), 'dep', dep, 'lib', forge.api)
			if os.path.exists(lib_path):
				src = lib_path
				dst = forge.libPath

				for f in os.listdir(src):
					if f[0] != '.':
						if re_lib.match(f):
							fn = os.path.join(src,f)
							shutil.copy2(fn, dst)

				src = os.path.join(os.path.dirname(forge.rootPath), 'dep', dep, 'include')
				dst = os.path.join(forge.libPath, dep)
				if not os.path.exists(dst):
					os.makedirs(dst)

				for f in os.listdir(src):
					if f[0] != '.':
						src_d = os.path.join(src, f)
						dst_d = os.path.join(dst, f)
						if os.path.isdir(src_d):
							if os.path.exists(dst_d):
								shutil.rmtree(dst_d)
							shutil.copytree(src_d, dst_d)
						else:
							shutil.copy2(src_d, dst_d)

				forge.includemap[dep] = os.path.join(dst)


